#!/usr/bin/env python
# -*- coding: latin-1 -*-
# Christophe CARON www.caron.ws

import RPi.GPIO as GPIO, time
import sys
GPIO.setmode(GPIO.BCM)			
PORT = 17						# Port utiliser
GPIO.setup(PORT, GPIO.IN)		# Initialisation du port
temps= 0						# Initialisation variable temp
temps1= 0						# Initialisation variable temp
dtemps=1						# Initialisation variable delta entre temps et temps1
bits = 0						# Initialisation variable bits dans trame
vparite=0						# controle parit

#Cration du tableau reprsentant des 59 bits
i=0
tableau=[]
while i < 61:
    tableau.append(i)
    i=i+1

# Boucle de lecture

while True:
    if bits>59 or dtemps<=0:						# Vrification de la transmission si plus de 59 donnes et si temps infrieur a zro entre deux bits
        print u"Problme rception"                 # Message Problme de rception
        bits=0                                      # Mise  zro l'index du tableau 
        vparite = 0	                                # Mise  zro la vrification de la parit	
    if (temps - temps1)> 2:                         # Si on dpasse 2sec c'est que on  fini la trame
        if bits ==59:                               # Si on a 59 bits c'est que l'on peut dcoder la trame
            print " "
            print u"Synchro ok"
            parite = (tableau[22] + tableau[23] + tableau[24] + tableau[25] + tableau[26] + tableau[27] + tableau[28])      #Vrification parit minutes
            if parite%2==tableau[29]:                                                                                       # si ok on ajoute 1
                vparite= vparite + 1
            parite = (tableau[30] + tableau[31] + tableau[32] + tableau[33] + tableau[34] + tableau[35])                    # vrification parit heures
            if parite%2==tableau[36]:                                                                                       # si ok on ajoute 1
                vparite = vparite + 1
            i=37
            parite = 0
            while i <59:                                                                                                    # vrification parit jour mois anne
                parite = tableau[i]+parite
                i=i+1
            if parite%2==tableau[59]:                                                                                       # Si ok on ajoute 1
                vparite = vparite + 1
            valeurm = (tableau[22]*1 + tableau[23]*2 + tableau[24]*4 + tableau[25]*8 + tableau[26]*10 + tableau[27]*20 + tableau[28]*40)       #valeur minutes
            valeurh = (tableau[30]*1 + tableau[31]*2 + tableau[32]*4 + tableau[33]*8 + tableau[34]*10 + tableau[35]*20)                        #Valeur des heures
            valeurj = (tableau[37]*1 + tableau[38]*2 + tableau[39]*4 + tableau[40]*8 + tableau[41]*10 + tableau[42]*20)                        #valeur des jours
            valeurmo = (tableau[46]*1 + tableau[47]*2 + tableau[48]*4 + tableau[49]*8 + tableau[50]*10)                                        #valeur des mois
            valeura = (tableau[51]*1 + tableau[52]*2 + tableau[53]*4 + tableau[54]*8 + tableau[55]*10 + tableau[56]*20 + tableau[57]*40 + tableau[58]*80) #Valeur des dizaines d'annes
            if vparite==3:                                                                                                  # si les trois controle de parit sont bons
                print u"Parit ok"                                                                                          # On affiche les valeurs
                print "Heure "+str(valeurh) + ":"+ str(valeurm) + ":" + "00" + " - Date " + str(valeurj) + "/" + str(valeurmo) + "/20" + str(valeura)  #affichage
            else:
                print u"dfaut de parit"
        if bits != 0:                                                 # si bits diffrent de zro c'est la fin de la trame car temps suprieur a 2 sec
            print "fin de la trame"
        bits=0
        vparite = 0
    if( GPIO.input( PORT ) == 1 ):                                    # lecture de l'tat du port si  1
        time.sleep(0.01)	                                          # Pause de 0.01 sec anti rebond
    if( GPIO.input( PORT ) == 1 ):                                    # lecture de l'tat du port si  1 
        temps = (int(time.strftime('%S',time.localtime()))+1)         # dfinition du temps
        time.sleep(0.16)                                              # pause de 160ms
        bits = bits + 1                                               # incrmentation pour le tableau de valeur
        sys.stdout.write("*")                                         # affichage de l'toile
        sys.stdout.flush()                                            # afichage de l'toile
        if ( GPIO.input( PORT ) == 1 ):                               # si port  1 c'est un 1 recu au niveau de la valeur
            time.sleep(0.6)                                           # pause de 600ms retour du signale  zro
            temps1 = int(time.strftime('%S',time.localtime()))        # lecture du temps 1
            tableau[bits]=1                                           # valeur dans le tableau entre a 1
            dtemps = (temps - temps1)
        else:                                                         # valeur est donc zro
            time.sleep(0.6)                                           # pause de 600ms retour du signale  zro
            tableau[bits]=0                                           # valeur dans le tableau entre a 0
            temps1 = int(time.strftime('%S',time.localtime()))        # lecture du temps 1
            dtemps = (temps - temps1)                                 # delta de temps 
    else :
            temps1 = int(time.strftime('%S',time.localtime()))        # lecture du temps 1 